/*   v1.0
*
*    Robot object avoidance using SRF05 Ultrasonic Rangefinder mounted on servo
*    Motor control-L293
*
*    Cory Grant 2009
*    cory.grant11@gmail.com
*
* 
*    Future Versions- TSL light sensor(light seeking), wireless communication to Wii Nunchuck(Remote Control)
*
*/



#include <Servo.h>   //include Servo library

Servo servo;  // Create servo object to control a servo 

int minDist = 8;          // Minimum distance for SRF05
int motorDelay = 500;      //Milliseconds motors stay on when moving
char letter;              //Character for either Autonomous or Remote
char letter2;             //Character for Remote Control
int serialAvail = 0;      //Variable to listen to Serial or not


int motA1 = 2;            //Wire color=Blue
int motA2 = 3;            //Wire color=White
int motB1 = 4;            //Wire color=Green
int motB2 = 5;            //Wire color=Yellow
int srfIN = 6;            //Wire color=Blue
int srfOUT= 7;            //Wire color=Yellow
///int lightPin = 8;      //Pin for TSL light sensor
int servoPin = 9;         //Wire color=White
int beepPin = 13;


int servoArray[] = {45, 90, 135};   //Array to store servo positions
int srfArray[3];                    //Array to store SRF data at each servo position
int arrayPos = 0;                   //Index for array
int servoPos = 0;                   //Variable for servo position


void setup(){
    Serial.begin(9600);
  
    pinMode(motA1, OUTPUT);
    pinMode(motA2, OUTPUT);
    pinMode(motB1, OUTPUT);
    pinMode(motB2, OUTPUT);
    pinMode(srfIN, INPUT);
    pinMode(srfOUT, OUTPUT);
    //pinMode(lightPin, INPUT);
    pinMode(servoPin, OUTPUT);
  
    servo.attach(servoPin);            
    
 }


void loop(){
  
  if (Serial.available()){
    serialAvail = 1;                      
  }
  else{
    serialAvail = 0;
  }
  
  while(serialAvail != 1){             
  forwards();                           
  scan();
   if (Serial.available()){
    serialAvail = 1;
  }
  else{
    serialAvail = 0;
  }}
  
  
  
  while(serialAvail == 1){
  Serial.println("Type A (Autonomous) or R (Remote Control)");
  letter=Serial.read();
  if (letter == 'A' || letter == 'a'){  
  serialAvail=0;
  }
  else{ if (letter == 'R' || letter == 'r'){
    stop();
    while(serialAvail == 1){
    macControl();}
  }
  else{ 
    Serial.println("Input must be A or R");
  }}
}}





void turnLeft(){
  digitalWrite(motA1,HIGH);
  digitalWrite(motA2,LOW);
  digitalWrite(motB1,LOW);
  digitalWrite(motB2,HIGH);
}




void turnRight(){
  digitalWrite(motA1,LOW);
  digitalWrite(motA2,HIGH);
  digitalWrite(motB1,HIGH);
  digitalWrite(motB2,LOW);
}



void forwards(){
  digitalWrite(motA1,HIGH);
  digitalWrite(motA2,LOW);
  digitalWrite(motB1,HIGH);
  digitalWrite(motB2,LOW);
}




void backwards(){
   digitalWrite(motA1,LOW);
  digitalWrite(motA2,HIGH);
  digitalWrite(motB1,LOW);
  digitalWrite(motB2,HIGH);
}





void stop(){
  digitalWrite(motA1,HIGH);
  digitalWrite(motA2,HIGH);
  digitalWrite(motB1,HIGH);
  digitalWrite(motB2,HIGH);
}




void setServo(int pos){
  servo.write(pos);
  delay(500);
}




int readSRF(){
  int distance = 0;
  int pulseTime = 0; 
  Serial.println("SRF READ");
  digitalWrite(srfOUT, HIGH);
  delayMicroseconds(20);
  digitalWrite(srfOUT, LOW);

  pulseTime = pulseIn(srfIN, HIGH);
  distance = pulseTime/148;
  return distance;
}





void scan(){
   for (int i = 0; i <= 2; i++){
   setServo(servoArray[i]);
   srfArray[i] = readSRF();
   
   if (srfArray[0] < minDist){
    beep();
    stop();
    delay(500);
    leftProx();
  }
  else{if(srfArray[1] < minDist){
    beep();
    stop();
    delay(500);
    centerProx();
  }
  else{if(srfArray[2] < minDist){
    beep();
    stop();
    delay(500);
    rightProx();
  }}}}
 
  //Serial.print(0xFE, BYTE);   //command flag
  //Serial.print(0x01, BYTE);   //clear command.
  Serial.print("SCAN  ");
  Serial.print(srfArray[0]);
  Serial.print(", ");
  Serial.print(srfArray[1]);
  Serial.print(", ");
  Serial.print(srfArray[2]);
  Serial.print('\n');
  }

  
  
  
  
void leftProx(){
    
   for (int i = 0; i <= 2; i++){
   setServo(servoArray[i]);
   srfArray[i] = readSRF();
 
  //Serial.print(0xFE, BYTE);   //command flag
  //Serial.print(0x01, BYTE);   //clear command.
  Serial.print("LEFTPROX  ");
  Serial.print(srfArray[0]);
  Serial.print(", ");
  Serial.print(srfArray[1]);
  Serial.print(", ");
  Serial.print(srfArray[2]);
  Serial.print('\n');
 
  
 if (srfArray[0] < minDist && srfArray[1] > minDist && srfArray[2] < minDist){
   //Serial.print(0xFE, BYTE);   //command flag
   //Serial.print(192, BYTE);    //position
   Serial.print("SPLIT"); 
   Serial.print('\n');
   forwards();
  }
  else{if(srfArray[0] < minDist && srfArray[1] > minDist && srfArray[2] > minDist){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("OLEFT");
   Serial.print('\n'); 
    backwards();
    delay(motorDelay);
    turnRight();
    delay(motorDelay);
  }
  else{if(srfArray[0] < minDist && srfArray[1] < minDist && srfArray[2] < minDist){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("WALL"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);
    
  }
  else{if(srfArray[0] < minDist && srfArray[1] < minDist && srfArray[2] > minDist){
    //Serial.print(0xFE, BYTE);
    //Serial.print(192, BYTE);
    Serial.print("OLEFT+OCENTER");
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnRight();
    delay(motorDelay);
  }}}}}}    


void centerProx(){
    
   for (int i = 0; i <= 2; i++){
   setServo(servoArray[i]);
   srfArray[i] = readSRF();
 
  //Serial.print(0xFE, BYTE);   //command flag
  //Serial.print(0x01, BYTE);   //clear command.
  Serial.print("CENTERPROX  ");
  Serial.print(srfArray[0]);
  Serial.print(", ");
  Serial.print(srfArray[1]);
  Serial.print(", ");
  Serial.print(srfArray[2]);
  Serial.print('\n');
  
 if (srfArray[1] < minDist && srfArray[0] > srfArray[2]){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("OCENTER-LEFT>"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);
  }
  else{if(srfArray[1] < minDist && srfArray[0] < srfArray[2]){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("OCENTER-RIGHT>"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnRight();
    delay(motorDelay);
  }
  else{if(srfArray[0] < minDist && srfArray[1] < minDist && srfArray[2] < minDist){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("WALL"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);
  }}}}}
  
  
  
  
void rightProx(){
    
   for (int i = 0; i <= 2; i++){
   setServo(servoArray[i]);
   srfArray[i] = readSRF();
 
  //Serial.print(0xFE, BYTE);   //command flag
  //Serial.print(0x01, BYTE);   //clear command.
  Serial.print("RIGHTPROX  ");
  Serial.print(srfArray[0]);
  Serial.print(", ");
  Serial.print(srfArray[1]);
  Serial.print(", ");
  Serial.print(srfArray[2]);
  Serial.print('\n');
  
 if (srfArray[2] < minDist && srfArray[1] > minDist && srfArray[0] < minDist){
   //Serial.print(0xFE, BYTE);   //command flag
   //Serial.print(192, BYTE);    //position
   Serial.print("SPLIT");  
   Serial.print('\n');
   forwards();
  }
  else{if(srfArray[2] < minDist && srfArray[1] > minDist && srfArray[0] > minDist){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("ORIGHT"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);
  }
  else{if(srfArray[2] < minDist && srfArray[1] < minDist && srfArray[0] < minDist){
    //Serial.print(0xFE, BYTE);   //command flag
    //Serial.print(192, BYTE);    //position
    Serial.print("WALL"); 
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);}
  else{if(srfArray[2] < minDist && srfArray[1] < minDist && srfArray[0] > minDist){
    //Serial.print(0xFE, BYTE);
    //Serial.print(192, BYTE);
    Serial.print("ORIGHT+OCENTER");
    Serial.print('\n');
    backwards();
    delay(motorDelay);
    turnLeft();
    delay(motorDelay);
  }}}}}}
  


void macControl(){
  Serial.println("Type L (Left) R (Right) F (Forward) B (Backward) S (Stop)");
  letter2 = Serial.read();
  if (letter2 == 'L' || letter2 == 'l'){
    turnLeft();
  }
  else{ if(letter2 == 'R' || letter2 == 'r'){
    turnRight();
  }
  else{ if(letter2 == 'F' || letter2 == 'f'){
    forwards();
  }
  else{ if(letter2 == 'B' || letter2 == 'b'){
    backwards();
  }
  else{if(letter2 == 'S' || letter2 == 's'){
    stop();
  }
  else{if(letter2 == 'A' || letter2 == 'a'){
    serialAvail = 0;
  }
  else{
    Serial.println("Must type L,R,F,B,or S");
  }}}}}}}
  
void beep(){
    for( int i = 0; i < 75; i++ ) {   // play it for 50 cycles
        digitalWrite(beepPin, HIGH);
        delayMicroseconds(1500);
        digitalWrite(beepPin, LOW);
        delayMicroseconds(1500);
}
    for( int i = 0; i < 75; i++ ) {   // play it for 50 cycles
        digitalWrite(beepPin, HIGH);
        delayMicroseconds(900);
        digitalWrite(beepPin, LOW);
        delayMicroseconds(900);
}}
